<?php
/*
 /////////////////// DISCLAIMER ///////////////////////////
 THIS EXAMPLE CODE IS PROVIDED TO YOU ONLY ON AN "AS IS"
 BASIS WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND,
 EITHER EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION
 ANY WARRANTIES OR CONDITIONS OF TITLE, NON-INFRINGEMENT,
 MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE.
 PAYPAL MAKES NO WARRANTY THAT THE SOFTWARE OR
 DOCUMENTATION WILL BE ERROR-FREE. IN NO EVENT SHALL THE
 COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY
 DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
 CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
 PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF
 USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
 CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT,
 STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF
 ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 ////////////////////////////////////////////////////////////
 */

//Get access token from PayPal
include 'create-token.php';

//Print all errors
error_reporting(E_ALL);
ini_set("display_errors", 1);


//Initiate CURL and set url endpoint
$ch = curl_init();
$url = 'https://api.sandbox.paypal.com/v1/notifications/webhooks';
curl_setopt($ch, CURLOPT_URL, $url);

curl_setopt($ch, CURLOPT_SSLVERSION, CURL_SSLVERSION_TLSv1_2);

//Should to be set to true for security
curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, FALSE);
//Should be set to 2 for security
curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, 0);

//Cert can be generated through mozilla firefox and is used when implementing security for VERIFYPEER and VERIFYHOST in the above
//curl_setopt($ch, CURLOPT_CAINFO, '/var/www/html/Example_REST_PO/cert/cacert.pem');

//Set headers including access token
$headers = array(
    'Accept: application/json',
    'Content-Type: application/json',
    'Accept-Language: en_US',
    "Authorization: Bearer $accessToken"
);
curl_setopt($ch,CURLOPT_HTTPHEADER,$headers);

//Lets curl know we are using 'post' and not 'get' (false = 'get')
curl_setopt($ch, CURLOPT_POST, TRUE);

//Keep connection open until we get data back
curl_setopt($ch, CURLOPT_RETURNTRANSFER, TRUE);

//Reset the array
$vars= [];

//Add the webhook url to the request body
$vars['url'] = 'https://example.com/example_webhook';

//Specify each webhook type and add them to an array
$eventType1['name'] = 'PAYMENT.AUTHORIZATION.CREATED';
$eventType2['name'] =  'PAYMENT.AUTHORIZATION.VOIDED';
$eventTypes = array($eventType1,$eventType2);

//Add the event type array to the request body
$vars['event_types'] = $eventTypes;


//Print the request body variables
// echo "<pre>";
// print_r($vars);
// echo "</pre>";

//Build and set the json structure
$json = json_encode($vars);
curl_setopt($ch, CURLOPT_POSTFIELDS, $json);


//Get the response
$response = curl_exec($ch);

//Parse json into an array
$outArray = json_decode($response, true);

//Print the response
echo "<pre>";
print_r($outArray);
echo "</pre>";

//Verify that the webhook was created successfully
if($outArray['id'] != null)
{
    //Store the webhook id in the session for later use
    $_SESSION['webhookId'] = $outArray['id'];
    
    ?>

<!DOCTYPE html>

<head>
<!-- Add meta tags for mobile and IE -->
<meta name="viewport" content="width=device-width, initial-scale=1">
<meta http-equiv="X-UA-Compatible" content="IE=edge" />

<style type="text/css">
a.button {
    -webkit-appearance: button;
    -moz-appearance: button;
    appearance: button;
    
    text-decoration: none;
    color: initial;
    width:33.3%;
}

.bar{
    margin-left: 10%;
}
​
</style>
</head>

<body>

<div class="bar">
<a href="http://localhost/Sample_REST_Webhooks/listAllWebhooks.php" class="button">List All Webhooks</a>
<a href="http://localhost/Sample_REST_Webhooks/deleteWebhook.php" class="button">Delete Webhook</a>
<a href="http://localhost/Sample_REST_Webhooks/updateWebhook.php" class="button">Update Webhook</a>
<a href="http://localhost/Sample_REST_Webhooks/showWebhookDetails.php" class="button">Show Webhook Details</a>
</div>

</body>
<?php 
}
else
{
    //return user to store
    echo 'Sorry could not create webhook, please return to the store and try again';
    echo '<br><br>';
    echo"<a href='http://localhost/Sample_REST_Webhooks/index.php'>return to store</a>";
}